#include<stdio.h>
#include<stdlib.h>
#include<fcntl.h>
#include<unistd.h>
#include<sys/stat.h>
#include<string.h>

#include"DspLib.h"
#include"ConfigLib.h"
#include"Constants.h"
#include"DebugLib.h"

#ifdef ESD_SOUND
#include<esd.h>
#endif

/*
** Cration d'un fichier de conf par dfaut
*/
int dsp_initialisation(t_gmurfrc* gmurfrc)
{
  t_dsprc* tmpdsprc;
  int      init_flag;

  tmpdsprc = gmurfrc->first_dsp;
  init_flag = FALSE_;
  while(tmpdsprc != NULL)
    {
      tmpdsprc->dsp = open_dsp_for_play(tmpdsprc->name, 
					tmpdsprc->bits_per_sample,
					tmpdsprc->channels,
					tmpdsprc->sample_rate,
					tmpdsprc->esd_client);
      if ((tmpdsprc->dsp != NULL) && (init_flag == FALSE_))
	{
	  init_flag = TRUE_;
	  gmurfrc->first_dsp_in_list = tmpdsprc->dsp;
	}

      tmpdsprc = tmpdsprc->next_dsp;
    } // while

  if (init_flag == FALSE_)
    {
      warning("ConfigLib.c: dsp_initialization: I couldn't initialize any of "
	      "the dsps\nthat were specified");
      /*      tmpdsprc = (t_dsprc*)malloc(sizeof(t_dsprc));
	      tmpdsprc->next_dsp        = NULL;
	      tmpdsprc->bits_per_sample = DEF_BPS;
	      tmpdsprc->channels        = DEF_CHNS;
	      tmpdsprc->sample_rate     = DEF_RATE;
	      strcpy(tmpdsprc->esd_client,"");
	      strcpy(tmpdsprc->vendor,"Sounds of Silence quiet device");
	      tmpdsprc->dsp = (t_dsp*)malloc(sizeof(t_dsp));
	      tmpdsprc->dsp->file = open("/dev/null", O_WRONLY);
	      tmpdsprc->dsp->duplex = TRUE_;
	      gmurfrc->first_dsp = tmpdsprc;*/
      return (-1);
    }
  return(0);
}


/*
** gmurfrc_detectEsounD - Great! Network sound device sharing!
*/
#ifdef ESD_SOUND
int gmurfrc_detectEsounD(t_gmurfrc* tempgmurfrc)
{
  char  config_dir[MAX_LINE_LEN];
  char  esd_server_name[MAX_LINE_LEN];
  char  str[MAX_LINE_LEN];
  int   esd_server;
  FILE* fd;
  t_dsprc* my_dsp; 
  t_dsprc* temp_dsp;
  char  num[4];

  strcpy(num, "00");
  strcpy(config_dir, getenv("HOME")) ;
  strcat(config_dir, "/.gmurf/") ;
  strcat(config_dir, ESD_CONFIG_FILE);
  strcpy(esd_server_name, ESD_LOCAL_SERVER);
  fd = fopen(config_dir, "r");

  printf("\nInitializing EsounD devices...\n");
  if (fd == NULL)
    {
      printf("%s not found.\n",config_dir);
    }

  while ((strcmp(esd_server_name,"") != 0) && (strcmp(esd_server_name,"\n") != 0))
    {
      esd_server = esd_play_stream(ESD_BITS16 | ESD_STEREO | ESD_STREAM | ESD_PLAY, 44100, esd_server_name, ESD_GMURF_ID);
      
      if (esd_server >= 0)
	{
	  printf("Connected to %s\n",esd_server_name);
	  my_dsp = (t_dsprc*) malloc(sizeof(t_dsprc));
	  my_dsp->next_dsp        = NULL;
	  my_dsp->bits_per_sample = DEF_BPS;
	  my_dsp->channels        = DEF_CHNS;
	  my_dsp->sample_rate     = DEF_RATE;
	  strcpy(my_dsp->esd_client,esd_server_name);
	  //      my_dsp->dsp->file       = esd_server;
	  strcpy(str,"ESD device ");
	  strcat(str,num);
      	  strcat(str," on ");
	  strcat(str,esd_server_name);
	  if (num[1] != '9')
	    num[1]++;
	  else
	    {
	      num[0]++;
	      num[1] = '0';
	    }
	  strcpy(my_dsp->vendor,str);
	  if (tempgmurfrc->first_dsp == NULL)
	    tempgmurfrc->first_dsp = my_dsp;
	  else
	    {
	      temp_dsp = tempgmurfrc->first_dsp;
	      while(temp_dsp->next_dsp != NULL)
		temp_dsp = temp_dsp->next_dsp;
	      temp_dsp->next_dsp = my_dsp;
	    }
	  esd_close(esd_server);
	}
      else
	{
	  printf("Failed to connect to %s\n", esd_server_name);
	}
      if (fd != NULL)
	{
	  if (feof(fd) != 0)
	    break;
	  fgets(esd_server_name,MAX_LINE_LEN,fd); 
	  if ((strlen(esd_server_name)) > 0)
	    {
	      if (esd_server_name[strlen(esd_server_name)-1] == '\n')
		esd_server_name[strlen(esd_server_name)-1] = '\0';
	      else
		strcpy(esd_server_name, "");
	    }
	}
      else
	strcpy(esd_server_name, "");
    }
  return(0);
}
#endif

t_gmurfrc* gmurfrc_defaults(void)
{
  char       str[MAX_LINE_LEN];
  char       dspstr[MAX_LINE_LEN];
  t_gmurfrc* tempgmurfrc;
  t_dsprc*   my_dsp;
  t_dsprc*   temp_dsp;
  FILE*      sndstat;
  int        i;
  int        j;

  tempgmurfrc = (t_gmurfrc*) malloc(sizeof(t_gmurfrc));
  tempgmurfrc->first_dsp = NULL;
  j = 0;

  // EsounD Configuration

#ifdef ESD_SOUND
  gmurfrc_detectEsounD(tempgmurfrc);
#endif

  // OSS Configuration

#ifdef OSS_SOUND

  sndstat = fopen("/dev/sndstat", "r");
  
  if (sndstat != NULL)
    
    {
      strcpy(str,"");
      while(strcmp(str, "Audio devices:\n")!= 0)
	{
	  if (fgets(str, MAX_LINE_LEN, sndstat) == NULL )
	    break;
	}
      if (strcmp(str, "Audio devices:\n")==0) 
	{
	  printf("\nInitializing OSS devices...\n");
	  j = 0;
	  while((fgets(str, MAX_LINE_LEN, sndstat) != NULL) && strcmp(str,"\n")!=0)
	    {
	      j++;
	      str[strlen(str)-1] = '\0';
	      printf("Device %s\n",str);
	      my_dsp = (t_dsprc*) malloc(sizeof(t_dsprc));
	      strcpy(my_dsp->vendor,"OSS device ");
	      strcat(my_dsp->vendor,str);
	      strcpy(my_dsp->esd_client, "");
	      my_dsp->next_dsp        = NULL;
	      my_dsp->bits_per_sample = DEF_BPS;
	      my_dsp->channels        = DEF_CHNS;
	      my_dsp->sample_rate     = DEF_RATE;
	      strcpy(dspstr,"");
	
	      // Lets find the name of '/dev/dsp*' 
	      i = 0;
	      while(str[i] != ':')
		{
		  // strcat( dspstr, str[i]);
		  // len = strlen(dspstr);
		  dspstr[i] = str[i];
		  i++;
		}
	      dspstr[i] = '\0';

	      strcpy(my_dsp->name, "/dev/dsp");
	      if (strcmp(dspstr,"0") != 0)
		strcat(my_dsp->name, dspstr);
	      	      
	      // Okay.
	      if (tempgmurfrc->first_dsp == NULL)
		{	
		  tempgmurfrc->first_dsp = my_dsp;
		}
	      else
		{
		  temp_dsp = tempgmurfrc->first_dsp;
		  while(temp_dsp->next_dsp != NULL)
		    temp_dsp = temp_dsp->next_dsp;
		  temp_dsp->next_dsp = my_dsp;
		}
	    }
	}
      tempgmurfrc->num_of_dsps = j;
      tempgmurfrc->buffer_size = DEF_BUF;
      strcpy(tempgmurfrc->temp_dir,DEF_TMPD);
      if (dsp_initialisation(tempgmurfrc)!=0)
	{
	  warning("ConfigLib.c: gmurfrc_defaults: DSP initialisation failed."
		  " Returning NULL");
	  gmurfrc_destroy(tempgmurfrc);
	  return(NULL);
	}
      if (sndstat != NULL) 
	fclose(sndstat);      
      
      return(tempgmurfrc);
    }

  printf("\nOSS driver not detected (this is normal if you use the NetBSD OSS "
	 "emulator)\nUsing default sound settings.\n");
  tempgmurfrc->num_of_dsps = DEF_NDSP;
  tempgmurfrc->buffer_size = DEF_BUF;
  strcpy(tempgmurfrc->temp_dir,DEF_TMPD);
  tempgmurfrc->first_dsp = (t_dsprc*) malloc(sizeof(t_dsprc));
  tempgmurfrc->first_dsp->next_dsp        = NULL;
  tempgmurfrc->first_dsp->bits_per_sample = DEF_BPS;
  tempgmurfrc->first_dsp->channels        = DEF_CHNS;
  tempgmurfrc->first_dsp->sample_rate     = DEF_RATE;
  strcpy(tempgmurfrc->first_dsp->esd_client, "");
  strcpy(tempgmurfrc->first_dsp->name, DSP_DEVICE);
  strcpy(tempgmurfrc->first_dsp->vendor, "OSS Emulator device");

#endif // no_oss

  if (dsp_initialisation(tempgmurfrc)!=0)
	{
	  warning("ConfigLib.c: gmurfrc_defaults: DSP initialisation failed."
		  " Returning NULL");
	  gmurfrc_destroy(tempgmurfrc);
	  return(NULL);
	}

  tempgmurfrc->first_dsp_in_list = tempgmurfrc->first_dsp->dsp;
  //  strcpy(tempgmurfrc->first_dsp->name, DSP_DEVICE);

#ifdef OSS_SOUND
  if (sndstat != NULL)
    fclose(sndstat);
#endif

  return (tempgmurfrc);

} /* gmurf_defaults */

/*
** Lecture d'un fichier de conf 
*/

t_gmurfrc* gmurfrc_read(name)
     char* name; /* nom du fichier gmurfrc */
{
  int        tempfile;
  int        i;
  char       signature[]=GMURF_SIGNATURE;
  t_gmurfrc* tempgmurfrc; /* fichier de conf generale */
  t_dsprc*   tempdsprc;   /* element de la liste chane de DSPs */

  tempfile = open(name,O_RDONLY);
  if (tempfile == -1)
    {
    warning("ConfigLib.c: gmurfrc_read: Erreur lors de l'ouverture du fichier de conf");
    return(NULL); /* echec lors de l'ouverture du fichier */
    } /* if */

  read(tempfile, signature, sizeof(GMURF_SIGNATURE));
  if ( (memcmp(signature, GMURF_SIGNATURE, 10)) != 0)
    {
    warning("ConfigLib.c: gmurfrc_read: Erreur lors de l'identification de la signature du Gmurfrc");
    return (NULL);
    } /* if */

  tempgmurfrc = (t_gmurfrc*) malloc(sizeof(t_gmurfrc));
  read(tempfile, tempgmurfrc, sizeof(t_gmurfrc));

  if (tempgmurfrc->num_of_dsps != 0)
    {
      tempgmurfrc->first_dsp = (t_dsprc*) malloc(sizeof(t_dsprc));
      tempdsprc = tempgmurfrc->first_dsp;
      read(tempfile, tempdsprc, sizeof(t_dsprc));

      if (tempgmurfrc->num_of_dsps > 1) 
	{
	  for (i=1; i < tempgmurfrc->num_of_dsps; i++)
	    {
	      /* Allocation de l'lment suivant */
	      tempdsprc->next_dsp = (t_dsprc*) malloc(sizeof(t_dsprc)); 
	      tempdsprc = tempdsprc->next_dsp;

	      /* lecture de l'lment prsent de la liste */
	      read(tempfile, tempdsprc, sizeof(t_dsprc));    

	    } /* for */
	  tempdsprc->next_dsp = NULL;
	} /* if */

    } /* if */
  printf("before\n");
  close(tempfile);
  printf("after\n");
  return (tempgmurfrc);

} /* gmurfrc_read */

/*
** Ecriture d'un fichier de conf
*/

int gmurfrc_write(gmurfrc, filename)
     t_gmurfrc* gmurfrc;  /* Structure  sauvegarder */
     char*      filename; /* Nom du fichier  sauvegarder */
{
  int      tmpfile;
  int      i;
  t_dsprc* tempdsprc;

  if(gmurfrc == NULL)
    {
      warning("ConfigLib.c: gmurfrc_write:gmurfrc = NULL");
      return (-2);
    }

  tmpfile = open(filename, O_WRONLY | O_TRUNC | O_CREAT, 0644);
 
  if (tmpfile == -1)
    {
      warning("ConfigLib.c: gmurfrc_write: Erreur lors de l'ouverture en ecriture du fichier gmurfrc");
      return (-1);
    } /* if */

  write(tmpfile, GMURF_SIGNATURE, sizeof(GMURF_SIGNATURE));
  write(tmpfile, gmurfrc, sizeof(t_gmurfrc));
  tempdsprc = gmurfrc->first_dsp;

  for (i=1; i<=gmurfrc->num_of_dsps; i++)
    {
      write(tmpfile, tempdsprc, sizeof(t_dsprc));
      tempdsprc = tempdsprc->next_dsp;
    } /* for */

  close(tmpfile);
  return (0);
} /* gmurfrc_write */

/*
** gmurfrc_destroy: dsallocation de la structure gmurfrc 
*/

int gmurfrc_destroy(gmurfrc)
     t_gmurfrc* gmurfrc;
{
  
  t_dsprc* tempdsp;
  t_dsprc* tempdsp1;
      
  tempdsp = gmurfrc->first_dsp;
      
  /* parcours de la liste chane */
  while (tempdsp != NULL)
    {
      tempdsp1 = tempdsp->next_dsp;
      if (tempdsp->dsp != NULL)
	close_dsp(tempdsp->dsp);
      free(tempdsp);
      tempdsp = tempdsp1;
    } /* while */

  return (0);

} /* gmurfrc_destroy */

